HMWJGraph Class Reference

the main class to read the graphic part of a HanMac Word-J file More...

`#include <HMWJGraph.hxx>`

## Public Member Functions

| HMWJGraph (HMWJParser &parser)
| constructor More...
virtual | ~HMWJGraph ()
| destructor More...
int | version () const
| returns the file version More...
int | numPages () const
| returns the number of pages More...

## Protected Member Functions

bool | getColor (int colId, int patternId, MWAWColor &color) const
| returns the color associated with a pattern More...
bool | sendPageGraphics (std::vector< long > const &doNotSendIds)
| try to send the page graphic More...
void | flushExtra ()
| sends the data which have not yet been sent to the listener More...
bool | readFrames (MWAWEntry const &entry)
| try to read the frames definition (type 3) More...
shared_ptr < HMWJGraphInternal::Frame > | readFrame (int id)
| try to read a frame More...
shared_ptr < HMWJGraphInternal::BasicGraph > | readBasicGraph (HMWJGraphInternal::Frame const &header, long endPos)
| try to read the basic graph data More...
shared_ptr < HMWJGraphInternal::CommentFrame > | readCommentData (HMWJGraphInternal::Frame const &header, long endPos)
| try to read the comment data More...
shared_ptr < HMWJGraphInternal::PictureFrame > | readPictureData (HMWJGraphInternal::Frame const &header, long endPos)
| try to read the picture data More...
shared_ptr < HMWJGraphInternal::TableFrame > | readTableData (HMWJGraphInternal::Frame const &header, long endPos)
| try to read the table data More...
shared_ptr < HMWJGraphInternal::TextboxFrame > | readTextboxData (HMWJGraphInternal::Frame const &header, long endPos)
| try to read a textbox data More...
shared_ptr < HMWJGraphInternal::TextFrame > | readTextData (HMWJGraphInternal::Frame const &header, long endPos)
| try to read a text data (text, header/footer, footnote) More...
bool | readGroupData (MWAWEntry const &entry, int actZone)
| try to read the groupd data ( type 9 ) More...
bool | readGraphData (MWAWEntry const &entry, int actZone)
| try to read the graph data (zone 8) More...
bool | readPicture (MWAWEntry const &entry, int actZone)
| try to read the pictures definition (type 6) More...
bool | readTable (MWAWEntry const &entry, int actZone)
| try to read a table (zone 7) More...
bool | readTableFormatsList (HMWJGraphInternal::Table &table, long endPos)
| try to read a list of format More...
bool | sendFrame (HMWJGraphInternal::Frame const &frame, MWAWPosition pos, WPXPropertyList extras=WPXPropertyList())
| try to send a frame to the listener More...
bool | sendBasicGraph (HMWJGraphInternal::BasicGraph const &pict, MWAWPosition pos, WPXPropertyList extras=WPXPropertyList())
| try to send a basic picture to the listener More...
bool | sendComment (HMWJGraphInternal::CommentFrame const &textbox, MWAWPosition pos, WPXPropertyList extras=WPXPropertyList())
| try to send a comment box to the listener More...
bool | sendPictureFrame (HMWJGraphInternal::PictureFrame const &pict, MWAWPosition pos, WPXPropertyList extras=WPXPropertyList())
| try to send a picture frame More...
bool | sendEmptyPicture (MWAWPosition pos)
| try to send an empty picture More...
bool | sendTextbox (HMWJGraphInternal::TextboxFrame const &textbox, MWAWPosition pos, WPXPropertyList extras=WPXPropertyList())
| try to send a textbox to the listener More...
bool | sendTableUnformatted (long zId)
| try to send a table unformatted More...
std::map< long, int > | getTextFrameInformations () const
| return a list textZId -> type which type=0(main), 1(header), 2(footer), 3(footnote), 4(textbox), 9(table), 10(comment) More...
bool | getFootnoteInformations (long &textZId, std::vector< long > &fPosList) const
| return the footnote text zone id and the list of first char position More...
bool | sendFrame (long frameId, MWAWPosition pos, WPXPropertyList extras=WPXPropertyList())
| try to send a frame to the listener More...
bool | sendText (long textId, long fPos)
| ask main parser to send a text zone More...

## Protected Attributes

MWAWParserStatePtr | m_parserState
| the parser state More...
shared_ptr < HMWJGraphInternal::State > | m_state
| the state More...
HMWJParser * | m_mainParser
| the main parser; More...

## Private Member Functions

| HMWJGraph (HMWJGraph const &orig)
HMWJGraph & | operator= (HMWJGraph const &orig)

## Friends

class | HMWJParser
struct | HMWJGraphInternal::Table
class | HMWJGraphInternal::SubDocument

## Detailed Description

the main class to read the graphic part of a HanMac Word-J file

## Constructor & Destructor Documentation

HMWJGraph::HMWJGraph | ( | HMWJParser & | parser | ) |

constructor

HMWJGraph::~HMWJGraph | ( |  | ) |

virtual

destructor

HMWJGraph::HMWJGraph | ( | HMWJGraph const & | orig | ) |

private

## Member Function Documentation

void HMWJGraph::flushExtra | ( |  | ) |

protected

sends the data which have not yet been sent to the listener

bool HMWJGraph::getColor | ( | int | colId,
|  | int | patternId,
|  | MWAWColor & | color
| ) |  | const

protected

returns the color associated with a pattern

bool HMWJGraph::getFootnoteInformations | ( | long & | textZId,
|  | std::vector< long > & | fPosList
| ) |  | const

protected

return the footnote text zone id and the list of first char position

std::map< long, int > HMWJGraph::getTextFrameInformations | ( |  | ) | const

protected

return a list textZId -> type which type=0(main), 1(header), 2(footer), 3(footnote), 4(textbox), 9(table), 10(comment)

int HMWJGraph::numPages | ( |  | ) | const

returns the number of pages

HMWJGraph& HMWJGraph::operator= | ( | HMWJGraph const & | orig | ) |

private

shared_ptr< HMWJGraphInternal::BasicGraph > HMWJGraph::readBasicGraph | ( | HMWJGraphInternal::Frame const & | header,
|  | long | endPos
| ) |  |

protected

try to read the basic graph data

Referenced by readFrame().

shared_ptr< HMWJGraphInternal::CommentFrame > HMWJGraph::readCommentData | ( | HMWJGraphInternal::Frame const & | header,
|  | long | endPos
| ) |  |

protected

try to read the comment data

Referenced by readFrame().

shared_ptr< HMWJGraphInternal::Frame > HMWJGraph::readFrame | ( | int | id | ) |

protected

try to read a frame

Referenced by readFrames().

bool HMWJGraph::readFrames | ( | MWAWEntry const & | entry | ) |

protected

try to read the frames definition (type 3)

bool HMWJGraph::readGraphData | ( | MWAWEntry const & | entry,
|  | int | actZone
| ) |  |

protected

try to read the graph data (zone 8)

bool HMWJGraph::readGroupData | ( | MWAWEntry const & | entry,
|  | int | actZone
| ) |  |

protected

try to read the groupd data ( type 9 )

bool HMWJGraph::readPicture | ( | MWAWEntry const & | entry,
|  | int | actZone
| ) |  |

protected

try to read the pictures definition (type 6)

shared_ptr< HMWJGraphInternal::PictureFrame > HMWJGraph::readPictureData | ( | HMWJGraphInternal::Frame const & | header,
|  | long | endPos
| ) |  |

protected

try to read the picture data

Referenced by readFrame().

bool HMWJGraph::readTable | ( | MWAWEntry const & | entry,
|  | int | actZone
| ) |  |

protected

try to read a table (zone 7)

shared_ptr< HMWJGraphInternal::TableFrame > HMWJGraph::readTableData | ( | HMWJGraphInternal::Frame const & | header,
|  | long | endPos
| ) |  |

protected

try to read the table data

Referenced by readFrame().

bool HMWJGraph::readTableFormatsList | ( | HMWJGraphInternal::Table & | table,
|  | long | endPos
| ) |  |

protected

try to read a list of format

Referenced by readTable().

shared_ptr< HMWJGraphInternal::TextboxFrame > HMWJGraph::readTextboxData | ( | HMWJGraphInternal::Frame const & | header,
|  | long | endPos
| ) |  |

protected

try to read a textbox data

Referenced by readFrame().

shared_ptr< HMWJGraphInternal::TextFrame > HMWJGraph::readTextData | ( | HMWJGraphInternal::Frame const & | header,
|  | long | endPos
| ) |  |

protected

try to read a text data (text, header/footer, footnote)

Referenced by readFrame().

bool HMWJGraph::sendBasicGraph | ( | HMWJGraphInternal::BasicGraph const & | pict,
|  | MWAWPosition | pos,
|  | WPXPropertyList | extras = `WPXPropertyList()`
| ) |  |

protected

try to send a basic picture to the listener

Referenced by sendFrame().

bool HMWJGraph::sendComment | ( | HMWJGraphInternal::CommentFrame const & | textbox,
|  | MWAWPosition | pos,
|  | WPXPropertyList | extras = `WPXPropertyList()`
| ) |  |

protected

try to send a comment box to the listener

Referenced by sendFrame().

bool HMWJGraph::sendEmptyPicture | ( | MWAWPosition | pos | ) |

protected

try to send an empty picture

Referenced by HMWJGraphInternal::SubDocument::parse(), and sendPictureFrame().

bool HMWJGraph::sendFrame | ( | HMWJGraphInternal::Frame const & | frame,
|  | MWAWPosition | pos,
|  | WPXPropertyList | extras = `WPXPropertyList()`
| ) |  |

protected

try to send a frame to the listener

Referenced by flushExtra(), HMWJGraphInternal::SubDocument::parse(), sendFrame(), and sendPageGraphics().

bool HMWJGraph::sendFrame | ( | long | frameId,
|  | MWAWPosition | pos,
|  | WPXPropertyList | extras = `WPXPropertyList()`
| ) |  |

protected

try to send a frame to the listener

bool HMWJGraph::sendPageGraphics | ( | std::vector< long > const & | doNotSendIds | ) |

protected

try to send the page graphic

bool HMWJGraph::sendPictureFrame | ( | HMWJGraphInternal::PictureFrame const & | pict,
|  | MWAWPosition | pos,
|  | WPXPropertyList | extras = `WPXPropertyList()`
| ) |  |

protected

try to send a picture frame

Referenced by sendFrame().

bool HMWJGraph::sendTableUnformatted | ( | long | zId | ) |

protected

try to send a table unformatted

Referenced by HMWJGraphInternal::SubDocument::parse().

bool HMWJGraph::sendText | ( | long | textId,
|  | long | fPos
| ) |  |

protected

ask main parser to send a text zone

Referenced by HMWJGraphInternal::SubDocument::parse(), and HMWJGraphInternal::Table::sendText().

bool HMWJGraph::sendTextbox | ( | HMWJGraphInternal::TextboxFrame const & | textbox,
|  | MWAWPosition | pos,
|  | WPXPropertyList | extras = `WPXPropertyList()`
| ) |  |

protected

try to send a textbox to the listener

Referenced by sendFrame().

int HMWJGraph::version | ( |  | ) | const

returns the file version

## Friends And Related Function Documentation

friend class HMWJGraphInternal::SubDocument

friend

friend struct HMWJGraphInternal::Table

friend

friend class HMWJParser

friend

## Member Data Documentation

HMWJParser* HMWJGraph::m_mainParser

protected

the main parser;

Referenced by readFrames(), readGraphData(), readGroupData(), readTable(), readTableFormatsList(), and sendText().

MWAWParserStatePtr HMWJGraph::m_parserState

protected

the parser state

Referenced by flushExtra(), readBasicGraph(), readCommentData(), readFrame(), readFrames(), readGraphData(), readGroupData(), readPicture(), readPictureData(), readTable(), readTableData(), readTableFormatsList(), readTextboxData(), readTextData(), sendBasicGraph(), sendComment(), sendEmptyPicture(), sendFrame(), sendPageGraphics(), sendPictureFrame(), sendTableUnformatted(), sendTextbox(), and version().

shared_ptr<HMWJGraphInternal::State> HMWJGraph::m_state

protected

the state

Referenced by flushExtra(), getColor(), getFootnoteInformations(), getTextFrameInformations(), numPages(), readFrames(), readGraphData(), readGroupData(), readPicture(), readTable(), readTableFormatsList(), sendBasicGraph(), sendComment(), sendFrame(), sendPageGraphics(), sendTableUnformatted(), and sendTextbox().

The documentation for this class was generated from the following files:

- HMWJGraph.hxx
- HMWJGraph.cxx